
SCALE = 24576

def pack_vt(pos,norm)
    pos[0..2].map{(_1*SCALE).round}.pack('s<*')+norm.map{(_1*127).round}.pack('c*')+[(pos[3]*255).round].pack('C*')
end


obj_pos = []
obj_nrm = []
obj_face = []

File.readlines("teapot3.obj").each do |line|
    if line =~ /^v (-?[\d\.]+)+\s+(-?[\d\.]+)+\s+(-?[\d\.]+)+\s+(-?[\d\.]+)+\s+(-?[\d\.]+)+\s+(-?[\d\.]+)+/
        obj_pos << [$1.to_f,$2.to_f,$3.to_f,$5.to_f] # Also colors here (only care about green channel)
    elsif line =~ /^vn (-?[\d\.]+)+\s+(-?[\d\.]+)+\s+(-?[\d\.]+)+/
        obj_nrm << [$1.to_f,$2.to_f,$3.to_f]
    elsif line =~ /^f (\d+)\/\/(\d+)\s+(\d+)\/\/(\d+)\s+(\d+)\/\/(\d+)/
        obj_face << [$1.to_i-1,$2.to_i-1,$3.to_i-1,$4.to_i-1,$5.to_i-1,$6.to_i-1]
    end
end
p obj_pos.size,obj_nrm.size,obj_face.size

vertices = {}
indices = []

obj_face.each do |(p1,n1,p2,n2,p3,n3)|


    #puts 1,p1,n1
    vt1 = pack_vt(obj_pos[p1],obj_nrm[n1])
    #puts 2,p2,n2
    vt2 = pack_vt(obj_pos[p2],obj_nrm[n2])
    #puts 3,p3,n3
    vt3 = pack_vt(obj_pos[p3],obj_nrm[n3])

    indices << (vertices[vt1] ||= vertices.size)
    indices << (vertices[vt2] ||= vertices.size)
    indices << (vertices[vt3] ||= vertices.size)

end

teapot_data = String.new
teapot_data << [vertices.size].pack('S<')
teapot_data << [obj_face.size].pack('S<')
teapot_data << vertices.keys.join
teapot_data << indices.pack('S<*')

File.binwrite("teapot3.dat",teapot_data)